var initial_max_speed=1;
var bounce_max_delta=0.1;
var sphere_size=110;

var green,white,sphere;
var animation=null;
var particles;

var width,height;

var touching=false;
var touch_x,touch_y;

function init()
{
	green=document.getElementById("glow1");
	white=document.getElementById("glow0");
	sphere=document.getElementById("sphere");

	width=256;
	height=256;

	init_animation();

	if(window.widget)
	{
	    widget.onshow=start_animation;
	    widget.onhide=stop_animation;
	}

	var canvas_el=document.getElementById("canvas");
	canvas_el.onmouseover=touch_in;
	canvas_el.onmouseout=touch_out;
	canvas_el.onmousemove=touch_move;

	start_animation();
}

function init_animation()
{
	particles=[];

	for(var i=0;i<40;i++)
	{
		particles.push({
			r: vector.rand(),
			v: vector.rand()
		});
	}
}

function touch_in(e)
{
	touching=true;
	touch_x=e.pageX;
	touch_y=e.pageY;
}

function touch_out(e)
{
	touching=false;
}

function touch_move(e)
{
	touch_x=e.pageX;
	touch_y=e.pageY;
}

function start_animation()
{
	if(animation) return;

	var canvas_el=document.getElementById("canvas");
	var c=canvas_el.getContext("2d");

	var interval=40;
	var dt=interval/1000;

	animation=setInterval(function() {
		var touch=null;

		if(touching)
		{
			var x=(touch_x-width/2)/sphere_size;
			var y=(touch_y-height/2)/sphere_size;

			if(x*x+y*y<1)
			{
				touch=new vector(x,y,Math.sqrt(1-x*x-y*y));
			}
		}

		for(var i=0;i<particles.length;i++)
		{
			with(particles[i])
			{
				if(touch)
				{
					var d=touch.sub(r);
					var dist=d.abs();
					v=v.add(d.mul(2*dt/dist));
				}

				r=r.add(v.mul(dt));

				if(r.abs2()>1)
				{
					r=r.normalized();

					var v_norm=v.dot(r);
					var v_norm_new=Math.random();

					v=v.sub(r.mul(v_norm+v_norm_new));

				}
			}
		}

		draw_particles(c,particles);
	},interval);
}

function stop_animation()
{
	if(animation)
	{
		clearInterval(animation);
		animation=null;
	}
}

function draw_particles(c,particles)
{
	c.clearRect(0,0,256,256);

	c.save();
	//c.globalCompositeOperation="lighter";
	c.translate(width/2,height/2);
	c.scale(sphere_size,sphere_size);

	for(var i=0;i<particles.length;i++)
	{
		with(particles[i])
		{
			var scale=5/(r.z+5);
			var rnd=Math.random();
			var size=(0.1*rnd*rnd*rnd+0.07)*scale;
			c.drawImage(green,scale*r.x-size/2,scale*r.y-size/2,size,size);
		}
	}

	c.restore();

	c.drawImage(sphere,0,0);
}




function vector(x,y,z)
{
	this.x=x||0;
	this.y=y||0;
	this.z=z||0;

	this.abs=vector_abs;
	this.abs2=vector_abs2;
	this.add=vector_add;
	this.cross=vector_cross;
	this.div=vector_div;
	this.dot=vector_dot;
	this.mul=vector_mul;
	this.neg=vector_neg;
	this.normalized=vector_normalized;
	this.sub=vector_sub;
}

function vector_abs() { with(this) return Math.sqrt(x*x+y*y+z*z); }

function vector_abs2() { with(this) return x*x+y*y+z*z; }

function vector_add(v) { with(this) return new vector(x+v.x,y+v.y,z+v.z); }

function vector_cross(v) { with(this) return new vector(y*v.z-z*v.y,z*v.x-x*v.z,x*v.y-y*v.z); }

function vector_div(a) { with(this) return new vector(x/a,y/a,z/a); }

function vector_dot(v) { with(this) return x*v.x+y*v.y+z*v.z; }

function vector_mul(a) { with(this) return new vector(x*a,y*a,z*a); }

function vector_neg(v) { with(this) return new vector(-x,-y,-z); }

function vector_normalized(v) { var l=this.abs(); with(this) return new vector(x/l,y/l,z/l); }

function vector_sub(v) { with(this) return new vector(x-v.x,y-v.y,z-v.z); }

vector.rand=function()
{
	var x,y,z;
	do
	{
		x=Math.random()*2-1;
		y=Math.random()*2-1;
		z=Math.random()*2-1;
	}
	while(x*x+y*y+z*z>1);

	return new vector(x,y,z);
}
